# Setting up CMA server

You must create a docker image to run the Clouder Migration Assistant server. 
You can deploy it to any of your cluster nodes or an external node that has visibility to the cluster 
and has at least 1.5 GB of extra memory..

## Downloading CMA server

Download the latest CMA binaries from https://archive.cloudera.com/am2cm/2.6.0.0-14/. 
The supported version of the CMA is 2.4.0.0 and higher.

```shell
wget https://archive.cloudera.com/am2cm/2.6.0.0/tars/am2cm-all-2.6.0.0-14.tar.gz
```
or
```shell
curl https://archive.cloudera.com/am2cm/2.6.0.0/tars/am2cm-all-2.6.0.0-14.tar.gz --output am2cm-all-2.6.0.0-14.tar.gz
```

Extract the downloaded file.
```shell
tar xzf am2cm-all-2.6.0.0-14.tar.gz
```
## Starting CMA server

After extracting the compressed file, there are two ways to start the CMA server:
[in docker container](#starting-cma-server-in-docker-container) or [locally](#starting-cma-server-locally)

### Starting CMA server in Docker Container

Ensure that docker is installed on the host. For more information, see [installing docker engine](https://docs.docker.com/engine/install/) documentation.

Run the _cma-docker.sh_ script in the untarred top-level folder to launch the CMA server in a docker container.
```shell
am2cm-2.6.0.0-14/bin/cma-docker.sh --start
```

> **_NOTE:_** The script will automatically create the docker image if necessary. 
> Additionally, the script provides the following operations to manage the CMA docker container: 
> **start**,**stop**,**restart**,**rebuild**. If you want to know what other options are available, please see the help.
> ```am2cm-2.6.0.0-14/bin/cma-docker.sh --help```

### Starting CMA server locally

Ensure that Python 3.8 or later is installed on the host.

Run the _cma-local.sh_ script in the untarred top-level folder and follow its instructions to launch the CMA server locally.
```shell
am2cm-2.6.0.0-14/bin/cma-local.sh --start
```
> **_NOTE:_** The script will create a python virtual environment in the top-level folder where the dependencies will be installed.
> Additionally, the script provides the following operations to manage the CMA locally:
> **start**,**stop**,**restart**,**rebuild**. If you want to know what other options are available, please see the help.
> ```am2cm-2.6.0.0-14/bin/cma-local.sh --help```

\
\
\
After the AM2CM server starts, open http://localhost:8090 in a Chrome or Firefox browser. Cloudera Migration Assistant (CMA) Server opens.
This confirms that Cloudera Migration Assistant (CMA) Server is successfully installed.

![onestageupgrade1.png](images/onestageupgrade1.png)

